let cats = [];
let dogs = [];
let birds = [];
let butterflies = [];
let trees = [];
let flowers = [];

function setup() {
  createCanvas(800, 600);

  // Create cats
  for (let i = 0; i < 2; i++) {
    cats.push(
      new Animal('cat', random(width), random(height)),
    );
  }

  // Create dogs
  for (let i = 0; i < 2; i++) {
    dogs.push(
      new Animal('dog', random(width), random(height)),
    );
  }

  // Create birds
  for (let i = 0; i < 3; i++) {
    birds.push(
      new Animal('bird', random(width), random(height)),
    );
  }

  // Create butterflies
  for (let i = 0; i < 4; i++) {
    butterflies.push(
      new Animal(
        'butterfly',
        random(width),
        random(height),
      ),
    );
  }

  // Create trees
  for (let i = 0; i < 2; i++) {
    trees.push(
      new Plant('tree', random(width), height - 50),
    );
  }

  // Create flowers
  for (let i = 0; i < 5; i++) {
    flowers.push(
      new Plant(
        'flower',
        random(width),
        random(height - 50),
      ),
    );
  }
}

function draw() {
  background(220);

  // Draw trees
  for (let tree of trees) {
    tree.display();
  }

  // Draw flowers
  for (let flower of flowers) {
    flower.display();
  }

  // Draw birds
  for (let bird of birds) {
    bird.display();
    bird.update();
  }

  // Draw butterflies
  for (let butterfly of butterflies) {
    butterfly.display();
    butterfly.update();
  }

  // Draw cats
  for (let cat of cats) {
    cat.display();
    cat.update();
  }

  // Draw dogs
  for (let dog of dogs) {
    dog.display();
    dog.update();
  }
}

class Animal {
  constructor(type, x, y) {
    this.type = type;
    this.x = x;
    this.y = y;
    this.angle = random(TWO_PI);
    this.speed = random(1, 2);
  }

  update() {
    this.x += cos(this.angle) * this.speed;
    this.y += sin(this.angle) * this.speed;

    if (this.x > width) {
      this.x = 0;
    }
    if (this.y > height) {
      this.y = 0;
    }
  }

  display() {
    fill(255);
    noStroke();
    if (this.type === 'cat') {
      triangle(
        this.x,
        this.y,
        this.x - 10,
        this.y + 20,
        this.x + 10,
        this.y + 20,
      );
      ellipse(this.x, this.y, 20, 20);
    } else if (this.type === 'dog') {
      rect(this.x - 10, this.y - 5, 20, 10);
      ellipse(this.x - 10, this.y + 5, 10, 10);
      ellipse(this.x + 10, this.y + 5, 10, 10);
    } else if (this.type === 'bird') {
      ellipse(this.x, this.y, 10, 10);
      triangle(
        this.x - 5,
        this.y,
        this.x + 5,
        this.y - 5,
        this.x + 5,
        this.y + 5,
      );
    } else if (this.type === 'butterfly') {
      triangle(
        this.x,
        this.y,
        this.x - 5,
        this.y + 10,
        this.x + 5,
        this.y + 10,
      );
      triangle(
        this.x,
        this.y,
        this.x - 5,
        this.y - 10,
        this.x + 5,
        this.y - 10,
      );
    }
  }
}

class Plant {
  constructor(type, x, y) {
    this.type = type;
    this.x = x;
    this.y = y;
  }

  display() {
    fill(139, 69, 19);
    if (this.type === 'tree') {
      rect(this.x, this.y, 20, 50);
      fill(34, 139, 34);
      triangle(
        this.x - 20,
        this.y,
        this.x + 40,
        this.y,
        this.x + 10,
        this.y - 50,
      );
      triangle(
        this.x - 15,
        this.y - 20,
        this.x + 35,
        this.y - 20,
        this.x + 10,
        this.y - 70,
      );
    } else if (this.type === 'flower') {
      fill(random(255), random(255), random(255));
      ellipse(this.x, this.y, 10, 10);
      ellipse(this.x, this.y - 10, 5, 5);
      ellipse(this.x + 5, this.y + 5, 5, 5);
      ellipse(this.x - 5, this.y + 5, 5, 5);
    }
  }
}
